unit FFnpListBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FnpListBox, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    RadioGroup1: TRadioGroup;
    FnpListBox1: TFnpListBox;
    FnpListBox2: TFnpListBox;
    FnpListBox3: TFnpListBox;
    TabSheet4: TTabSheet;
    FnpListBox4: TFnpListBox;
    FnpListBox5: TFnpListBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FnpListBox3MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure FnpListBox4DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FnpListBox4DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FnpListBox4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FnpListBox2DrawCell(Sender: TObject; Index, Col: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FnpListBox3DrawCell(Sender: TObject; Index, Col: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FnpListBox1.ItemIndex := 0;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  FnpListBox1.MoveDown;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  FnpListBox1.MoveUp;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  FnpListBox1.DeleteSelected;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  S: String;
  X: Integer;
begin
  S := InputBox('Find', 'Enter artist', '');
  if length(S) > 0 then
  begin
    X := FnpListBox1.Find(S);
    if X > -1 then
      FnpListBox1.ItemIndex := X;
  end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if RadioGroup1.ItemIndex = 0 then
    FnpListBox1.Rearrange := True
  else
    FnpListBox1.Rearrange := False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Caption := IntToStr(FnpListBox1.Cols[0].WIdth);
end;

procedure TForm1.FnpListBox3MeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  Height := 13 + Index;
end;

procedure TForm1.FnpListBox4DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  Index: Integer;
  P: TPoint;
begin
  P.X := X;
  P.Y := Y;
  Index := TFnpListBox(Sender).ItemAtPos(P, True);
  if Index = -1 then
    TFnpListBox(Sender).Items.Add(TFnpListBox(Source).Items[TFnpListBox(Source).ItemIndex])
  else
    TFnpListBox(Sender).Items.Insert(Index, TFnpListBox(Source).Items[TFnpListBox(Source).ItemIndex]);
  TFnpListbox(Sender).ItemIndex := Index;
  TFnpListBox(Source).DeleteSelected;
end;

procedure TForm1.FnpListBox4DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if Sender = Source then
    Accept := False;
end;

procedure TForm1.FnpListBox4MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if TFnpListBox(Sender).Items.Count > 0 then
    TFnpListbox(Sender).BeginDrag(False);
end;

procedure TForm1.FnpListBox2DrawCell(Sender: TObject; Index, Col: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  DrawText(FnpListBox2.Canvas.Handle, PChar(IntToStr(Index)+'-'+IntToStr(Col)), -1,
    Rect, dt_SingleLine or dt_VCenter);
end;

procedure TForm1.FnpListBox3DrawCell(Sender: TObject; Index, Col: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  DrawText(FnpListBox3.Canvas.Handle, PChar(IntToStr(Index)+'-'+IntToStr(Col)), -1,
    Rect, dt_SingleLine or dt_VCenter);
end;

end.


